\name{attributionB}
\alias{attributionB}
\docType{data}
\title{
  Attribution Results for Population B
}
\description{
  Attribution results for Population B, generated by applying the \code{Attribution_sullivan()} function under a copula-based additive hazards model. This object contains age- and cause-specific contributions to disability prevalence and death probability, enabling decomposition of cohort health expectancy.
}
\usage{data(attributionB)}
\format{
  A list with the following components:
    \describe{
      \item{\code{Relative_Contributions_1}}{A matrix of age-cause-specific disability prevalence relative contributions. Rows represent causes (with the first row as total), columns represent age.}
      \item{\code{Relative_Contributions_2}}{A matrix of age-cause-specific death probability relative contributions. Format matches \code{Relative_Contributions_1}.}
      \item{\code{Absolute_Contributions_1}}{A matrix of age-cause-specific disability prevalence contributions. Rows represent causes (with the first row as total), columns represent age.}
      \item{\code{Absolute_Contributions_2}}{A matrix of age-cause-specific death probability contributions. Format matches \code{Absolute_Contributions_1}.}
      \item{\code{var_list}}{A character vector of cause names used in the attribution method.}
      \item{\code{age_seq}}{A vector of age range.}
    }
}
\source{
  Generated for the manuscript:
    Tao Sun, Huiping Zheng, and Xiaojun Wang (2025+).\\
  \emph{Decomposing Differences in Cohort Health Expectancy by Cause and Age with Longitudinal Data}.
}
\examples{
  data(attributionB)
  str(attributionB)
}
\keyword{datasets}
