% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fun_additive_S3.R
\name{summary.LongDecompHE}
\alias{summary.LongDecompHE}
\title{Summarizing outputs of a LongDecompHE object}
\usage{
\method{summary}{LongDecompHE}(object, ...)
}
\arguments{
\item{object}{a LongDecompHE object}

\item{...}{further arguments}
}
\value{
If the input is an attribution or decomposition object (e.g., from \code{Attribution_sullivan} or \code{Decomp_sullivan}),
the function prints summary tables of contributions to disability and death and returns the object invisibly.
Otherwise, it returns a list with model diagnostics including:
\itemize{
  \item \code{copula}: the copula family used.
  \item \code{m.dist}: marginal distribution type.
  \item \code{summary}: coefficient estimates and standard errors.
  \item \code{llk}: log-likelihood.
  \item \code{AIC}: Akaike Information Criterion.
  \item \code{code}: convergence code.
}
The returned object has class \code{"summary.LongDecompHE"}.
}
\description{
#' This function prints or returns a summary of results from an attribution or decomposition
analysis using the \code{LongDecompHE} framework.
}
